include:
  - project: emfollow/gitlab-ci-templates
    file: lint.yml
  - project: emfollow/gitlab-ci-templates
    file: sccb.yml

variables:
  # Allow Celery to run as root, because everything runs as root under Docker.
  C_FORCE_ROOT: 'true'
  # Checking out the source is the exception rather than the rule because
  # most of our CI jobs run from tarballs or wheels or don't require the source
  # at all.
  GIT_STRATEGY: none

.in-tmpdir: &in-tmpdir
  before_script:
    - WORKING_DIRECTORY="$(mktemp -d)"
    - cd "${WORKING_DIRECTORY}"
  after_script:
    - cd "${CI_PROJECT_DIR}"
    - rm -rf "${WORKING_DIRECTORY}"

stages:
  - dist
  - test
  - deploy

# Build source distribution
sdist:
  image: python:3.6-slim
  stage: dist
  variables:
    GIT_STRATEGY: fetch
  before_script:
    # Versioneer will need access to the git tool.
    - apt-get -q update
    - apt-get -yq install --no-install-recommends git
  script:
    - python setup.py sdist
    - mv dist/* .
  artifacts:
    paths:
      - '*.tar.gz'

# Build binary distribution
bdist:
  image: python:3.6-slim
  stage: test
  <<: *in-tmpdir
  script:
    - tar --strip-components 1 -xf ${CI_PROJECT_DIR}/*.tar.*
    - python setup.py bdist_wheel --dist-dir ${CI_PROJECT_DIR}
  dependencies:
    - sdist
  artifacts:
    paths:
      - '*.whl'

# Build Docker container for dependencies
.dependencies: &dependencies
  stage: dist
  variables:
    GIT_STRATEGY: fetch
    IMAGE_TAG: $CI_REGISTRY_IMAGE/$CI_JOB_NAME:$CI_COMMIT_REF_NAME
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - |
      cat <<EOF > Dockerfile
      FROM python:${CI_JOB_NAME#*python}
      COPY requirements.txt .
      RUN pip --no-cache-dir install -r requirements.txt
      RUN rm -f requirements.txt
      EOF
    - docker build -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
    - if [ "${CI_COMMIT_TAG:0:1}" = "v" ]; then docker tag $IMAGE_TAG ${IMAGE_TAG%:*}:latest; docker push ${IMAGE_TAG%:*}:latest; fi
  only:
    changes:
      - requirements.txt
dependencies/python3.6:
  <<: *dependencies
dependencies/python3.7:
  <<: *dependencies

# Run unit tests and coverage measurement
.test: &test
  stage: test
  coverage: '/^TOTAL\s+.*\s+(\d+\.?\d*)%/'
  <<: *in-tmpdir
  script:
    - apt-get update -qq && apt-get install -y -qq redis-server
    - tar --strip-components 1 -xf ${CI_PROJECT_DIR}/*.tar.*
    - pip install pytest-cov -r test-requirements.txt
    - python setup.py test --addopts="-vv --cov --cov-report=html:${CI_PROJECT_DIR}/htmlcov --cov-report=term --junit-xml=${CI_PROJECT_DIR}/junit.xml"
  dependencies:
    - sdist
  artifacts:
    paths:
      - htmlcov/
    reports:
      junit: junit.xml
test/python3.6:
  image: $CI_REGISTRY_IMAGE/dependencies/python3.6:$CI_COMMIT_REF_NAME
  <<: *test
test/python3.7:
  image: $CI_REGISTRY_IMAGE/dependencies/python3.7:$CI_COMMIT_REF_NAME
  <<: *test

lint:
  image: $CI_REGISTRY_IMAGE/dependencies/python3.6:$CI_COMMIT_REF_NAME
  stage: test
  variables:
    GIT_STRATEGY: fetch
  dependencies:
    - sdist

associate commits in Sentry:
  stage: test
  dependencies:
    - sdist
  variables:
    GIT_STRATEGY: fetch
  only:
    - master@emfollow/gwcelery
    - tags@emfollow/gwcelery
  image:
    name: getsentry/sentry-cli
    entrypoint: [""]
  script:
    # FIXME: Override git remote settings.
    # Remove this once git.ligo.org has Sentry initegraton turned on.
    - |
      cat <<EOF > .git/config
      [core]
        repositoryformatversion = 0
        filemode = true
        bare = false
        logallrefupdates = true
        ignorecase = true
        precomposeunicode = true
      [remote "origin"]
        url = https://github.com/lpsinger/gwcelery
        fetch = +refs/heads/*:refs/remotes/origin/*
      [branch "master"]
        remote = origin
        merge = refs/heads/master
      EOF
    - SENTRY_VERSION=$(echo *.tar.* | sed 's/\.tar\..*//')
    - sentry-cli releases new ${SENTRY_VERSION}
    - sentry-cli releases set-commits --auto ${SENTRY_VERSION}

# Build docker container for application itself
.docker: &docker
  stage: deploy
  script:
    - IMAGE_TAG=$CI_REGISTRY_IMAGE/${CI_JOB_NAME#*/}:$CI_COMMIT_REF_NAME
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - |
      cat <<EOF > Dockerfile
      FROM $CI_REGISTRY_IMAGE/dependencies/${CI_JOB_NAME#*/}:$CI_COMMIT_REF_NAME
      COPY *.whl .
      RUN pip install *.whl
      RUN rm -f *.whl
      USER nobody
      WORKDIR /tmp
      ENTRYPOINT ["gwcelery"]
      EOF
    - docker build -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
    - if [ "${CI_COMMIT_TAG:0:1}" = "v" ]; then docker tag $IMAGE_TAG ${IMAGE_TAG%:*}:latest; docker push ${IMAGE_TAG%:*}:latest; fi
  dependencies:
    - bdist
docker/python3.6:
  <<: *docker
docker/python3.7:
  <<: *docker

# Generate documentation
doc:
  image: python:3.6-slim
  stage: test
  <<: *in-tmpdir
  script:
    - apt-get update -qq && apt-get install -y -qq graphviz
    - tar --strip-components 1 -xf ${CI_PROJECT_DIR}/*.tar.*
    - python setup.py build_sphinx
  dependencies:
    - sdist

# SCCB request
sccb:
  stage: deploy

# Publish coverage
pages:
  stage: deploy
  script:
    - mv htmlcov public/
  artifacts:
    paths:
      - public
    expire_in: 30 days
  only:
    - master
  dependencies:
    - test/python3.6

# Upload package to PyPI
pypi:
  stage: deploy
  image: python:3.6-slim
  script:
    - pip install twine
    - twine upload *.tar.* *.whl
  dependencies:
    - sdist
    - bdist
  only:
    - tags@emfollow/gwcelery

# Create a release in GitLab
release:
  stage: deploy
  image: python
  variables:
    GIT_STRATEGY: fetch
  script:
    - PACKAGE_NAME="$(python setup.py --name)"
    - PACKAGE_VERSION="$(python setup.py --version)"
    - CHANGES_FILENAME="$(echo CHANGES.*)"
    - |
      tee json <<EOF
      {
        "name": "${PACKAGE_VERSION}",
        "tag_name": "${CI_COMMIT_TAG}",
        "description": "Version ${PACKAGE_VERSION}",
        "assets": {
          "links": [
            {
              "name": "PyPI",
              "url": "https://pypi.org/project/${PACKAGE_NAME}/${PACKAGE_VERSION}/"
            },
            {
              "name": "Change log",
              "url": "${CI_PROJECT_URL}/blob/v${VERSION}/${CHANGES_FILENAME}"
            },
            {
              "name": "Documentation",
              "url": "https://${PACKAGE_NAME}.readthedocs.io/en/v${PACKAGE_VERSION}/"
            }
          ]
        }
      }
      EOF
    - |
      if [ -n "$CI_COMMIT_TAG" ]
      then
        curl --silent --show-error --fail \
        --request POST --header "Private-Token: $GITLAB_ACCESS_TOKEN" \
        --header "Content-Type: application/json" \
        --data "@json" \
        "$CI_API_V4_URL/projects/$CI_PROJECT_ID/releases"
      fi

.deploy-common: &deploy-common
  stage: deploy
  image:
    name: ligo/ssh
    entrypoint: [""]
  only:
    - master@emfollow/gwcelery
    - tags@emfollow/gwcelery
  dependencies: []
  before_script:
    - umask 0077
    # Set up LSC DataGrid credentials
    - echo "${ROBOT_KEYTAB}" | base64 -d > keytab
    - kinit emfollow-deployment/robot/runners.ligo.uwm.edu@LIGO.ORG -k -t keytab
    - ligo-proxy-init -k -p
    - grid-proxy-info -identity
    # Figure out which user to log in as (emfollow or emfollow-playground)
    - mkdir -p ~/.ssh
    - |
      cat > ~/.ssh/config <<EOF
      Host emfollow-playground.*
      User emfollow-playground
      Host emfollow.*
      User emfollow
      EOF
    - REMOTE_HOST=${CI_ENVIRONMENT_URL##*//}
    - REMOTE_HOST=${REMOTE_HOST%%/*}
    - echo $REMOTE_HOST

# Continuous deployment.
# Note that all deployments except playground/CIT are manual.

.deploy-start: &deploy-start
  <<: *deploy-common
  script:
    # Update the repository.
    - |
      gsissh -T $REMOTE_HOST bash <<EOF
      set -e
      if [ ! -d .git ]; then git init; fi
      git fetch ${CI_REPOSITORY_URL}
      git fetch --tags ${CI_REPOSITORY_URL}
      git checkout -f $CI_COMMIT_SHA
      EOF
    # Reinstall and start (new session to reload bashrc).
    - |
      gsissh -T $REMOTE_HOST bash <<EOF
      . .bashrc
      set -e
      pip3.6 install --upgrade pipenv pip setuptools
      pipenv install --system --deploy
      # FIXME: remove pip uninstall temporary directories left behind due to
      # bug with pip on NFS. See https://github.com/pypa/pip/issues/6327
      chmod -R ug+rwx .local/lib/python3.6/site-packages/~* || true
      rm -rf .local/lib/python3.6/site-packages/~* || true
      gwcelery condor resubmit
      EOF

.deploy-stop: &deploy-stop
  <<: *deploy-common
  script: |
    gsissh -T $REMOTE_HOST bash <<EOF
    . .bashrc
    set -e
    gwcelery condor rm
    EOF

deploy to production at CIT:
  <<: *deploy-start
  when: manual
  environment:
    name: production/CIT
    on_stop: stop deployment on production at CIT
    url: https://emfollow.ligo.caltech.edu/flower

deploy to production at LHO:
  <<: *deploy-start
  when: manual
  environment:
    name: production/LHO
    on_stop: stop deployment on production at LHO
    url: https://emfollow.ligo-wa.caltech.edu/flower

deploy to playground at CIT:
  <<: *deploy-start
  environment:
    name: playground/CIT
    on_stop: stop deployment on playground at CIT
    url: https://emfollow-playground.ligo.caltech.edu/flower

deploy to playground at LHO:
  <<: *deploy-start
  when: manual
  environment:
    name: playground/LHO
    on_stop: stop deployment on playground at LHO
    url: https://emfollow-playground.ligo-wa.caltech.edu/flower

stop deployment on production at CIT:
  <<: *deploy-stop
  when: manual
  environment:
    name: production/CIT
    action: stop

stop deployment on production at LHO:
  <<: *deploy-stop
  when: manual
  environment:
    name: production/LHO
    action: stop

stop deployment on playground at CIT:
  <<: *deploy-stop
  when: manual
  environment:
    name: playground/CIT
    action: stop

stop deployment on playground at LHO:
  <<: *deploy-stop
  when: manual
  environment:
    name: playground/LHO
    action: stop
